searchNodes=[{"ref":"Membrane.Element.PortAudio.Sink.html","title":"Membrane.Element.PortAudio.Sink","type":"module","doc":"Audio sink that plays sound via multi-platform PortAudio library. Element options Passed via struct Membrane.Element.PortAudio.Sink.t/0 endpoint_id Default value: :default PortAudio sound card id ringbuffer_size Default value: 4096 Size of the ringbuffer (in frames) portaudio_buffer_size Default value: 256 Size of the portaudio buffer (in frames) latency Default value: :high Latency of the output device Pads :input Availability:always Bin?false CapsMembrane.Caps.Audio.Raw, restrictions:&nbsp;&nbsp;channels: 2,&nbsp;&nbsp;sample_rate: 48000,&nbsp;&nbsp;format: :s16le Demand&nbsp;unit:bytes Direction:input Mode:pull Name:input Clock This element provides a clock to its parent. This clock measures time by counting a number of samples consumed by a PortAudio device and allows synchronization with it."},{"ref":"Membrane.Element.PortAudio.Sink.html#membrane_pads/0","title":"Membrane.Element.PortAudio.Sink.membrane_pads/0","type":"function","doc":"Returns pads descriptions for Membrane.Element.PortAudio.Sink"},{"ref":"Membrane.Element.PortAudio.Sink.html#options/0","title":"Membrane.Element.PortAudio.Sink.options/0","type":"function","doc":"Returns description of options available for this module"},{"ref":"Membrane.Element.PortAudio.Sink.html#t:t/0","title":"Membrane.Element.PortAudio.Sink.t/0","type":"type","doc":"Struct containing options for Membrane.Element.PortAudio.Sink"},{"ref":"Membrane.Element.PortAudio.Source.html","title":"Membrane.Element.PortAudio.Source","type":"module","doc":"Audio source that captures sound via multi-platform PortAudio library. Element options Passed via struct Membrane.Element.PortAudio.Source.t/0 endpoint_id Default value: :default PortAudio sound card id portaudio_buffer_size Default value: 256 Size of the portaudio buffer (in frames) latency Default value: :high Latency of the output device Pads :output Availability:always Bin?false CapsMembrane.Caps.Audio.Raw, restrictions:&nbsp;&nbsp;channels: 2,&nbsp;&nbsp;sample_rate: 48000,&nbsp;&nbsp;format: :s16le Direction:output Mode:push Name:output"},{"ref":"Membrane.Element.PortAudio.Source.html#membrane_pads/0","title":"Membrane.Element.PortAudio.Source.membrane_pads/0","type":"function","doc":"Returns pads descriptions for Membrane.Element.PortAudio.Source"},{"ref":"Membrane.Element.PortAudio.Source.html#options/0","title":"Membrane.Element.PortAudio.Source.options/0","type":"function","doc":"Returns description of options available for this module"},{"ref":"Membrane.Element.PortAudio.Source.html#t:t/0","title":"Membrane.Element.PortAudio.Source.t/0","type":"type","doc":"Struct containing options for Membrane.Element.PortAudio.Source"},{"ref":"Membrane.Element.PortAudio.SyncExecutor.html","title":"Membrane.Element.PortAudio.SyncExecutor","type":"module","doc":"A GenServer executing actions received by GenServer.call/3 or send/2. Some PortAudio operations (such as starting and stopping stream) must not be executed concurrently, so they are received and executed here, synchronously."},{"ref":"Membrane.Element.PortAudio.SyncExecutor.html#apply/4","title":"Membrane.Element.PortAudio.SyncExecutor.apply/4","type":"function","doc":"A simple wrapper around GenServer.call/3."},{"ref":"Membrane.Element.PortAudio.SyncExecutor.html#child_spec/1","title":"Membrane.Element.PortAudio.SyncExecutor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Membrane.Element.PortAudio.SyncExecutor.html#start_link/1","title":"Membrane.Element.PortAudio.SyncExecutor.start_link/1","type":"function","doc":""},{"ref":"readme.html","title":"Membrane Multimedia Framework: PortAudio Element","type":"extras","doc":"Membrane Multimedia Framework: PortAudio Element This package provides Membrane Multimedia Framework elements that can be used to capture and play sound using multiplatform PortAudio library. Documentation is available at HexDocs."},{"ref":"readme.html#installation","title":"Membrane Multimedia Framework: PortAudio Element - Installation","type":"extras","doc":"Add the following line to your deps in mix.exs. Run mix deps.get. {:membrane_element_portaudio, &quot;~&gt; 0.3.1&quot;} You also need to have PortAudio installed."},{"ref":"readme.html#sample-usage","title":"Membrane Multimedia Framework: PortAudio Element - Sample usage","type":"extras","doc":"Playing below pipeline should play a raw file to default output device. defmodule Membrane.ReleaseTest.Pipeline do use Membrane.Pipeline alias Pipeline.Spec alias Membrane.Element.{PortAudio, File} @impl true def handle_init(_) do children = [ file_src: %File.Source{location: &quot;file.raw&quot;}, pa_sink: PortAudio.Sink ] links = %{ {:file_src, :output} =&gt; {:pa_sink, :input} } {{:ok, %Spec{children: children, links: links}}, %{}} end end And this one should forward sound from default input to default output. DO NOT USE WITHOUT HEADPHONES to avoid audio feedback. defmodule Membrane.ReleaseTest.Pipeline do use Membrane.Pipeline alias Pipeline.Spec alias Membrane.Element.PortAudio @impl true def handle_init(_) do children = [ pa_src: PortAudio.Source, pa_sink: PortAudio.Sink ] links = %{ {:pa_src, :output} =&gt; {:pa_sink, :input} } {{:ok, %Spec{children: children, links: links}}, %{}} end end"},{"ref":"readme.html#testing","title":"Membrane Multimedia Framework: PortAudio Element - Testing","type":"extras","doc":"Tests contain some cases that use portaudio stuff instead of mocking. Such cases require presence of at least one input and output soundcard, thus they are disabled by default. To enable them, run mix test --include soundcard"},{"ref":"readme.html#copyright-and-license","title":"Membrane Multimedia Framework: PortAudio Element - Copyright and License","type":"extras","doc":"Copyright 2018, Software Mansion Licensed under the Apache License, Version 2.0"}]